import {  Component } from '@angular/core';
import { NavController, NavParams } from 'ionic-angular';

import { SaleOrder } from "../../odoo/models/sale.order";
// import { SaleOrderLine } from "../../odoo/models/sale.order.line";
import { BaseDetailsView } from "../../base/base-details-view";

import { CustomerSelectionPage } from "./customer-selection/customer-selection";
import { ProductSelectionPage } from "./product-selection/product-selection";

@Component({
    selector: 'page-order',
    templateUrl: 'order.html'
})
export class OrderPage extends BaseDetailsView<SaleOrder> {

    cart = [
        {
            name: "Producto 001",
            price: 2000,
            qty: 1,
            subtotal: 2000
        },
        {
            name: "Producto 001",
            price: 2000,
            qty: 1,
            subtotal: 2000
        },
        {
            name: "Producto 001",
            price: 2000,
            qty: 1,
            subtotal: 2000
        },
        {
            name: "Producto 001",
            price: 2000,
            qty: 1,
            subtotal: 2000
        }
    ];

    constructor(
        public navCtrl: NavController,
        public navParams: NavParams
    ) { 
        super(SaleOrder, navParams.data.item, navParams.data.kind);

        let titleKind = super.getKind() === "budget" ? "Presupuesto" : "Venta";
        super.setTitle(super.itemExists() ? "Editar " + titleKind : "Crear " + titleKind);

        this.getTotal();
    }

    /**
     * 
     */
    ionViewDidLoad() {
        console.log('ionViewDidLoad OrderPage');
    }

    /**
     * 
     */
    selectCustomer(): void {
        this.navCtrl.push(CustomerSelectionPage);
    }

    getCart(): Array<any> {
        return this.cart;
    }

    getTotal(): number {
        let total: number = 0;

        for (let i = 0; i < this.getCart().length; i++) {
            total = total + this.getCart()[i].subtotal;
        }
        
        return total;
    }
    
    /**
     * 
     */
    openBarcodeReader(): void {

    }

    /**
     * 
     */
    selectProduct(): void {
        this.navCtrl.push(ProductSelectionPage);
    }

    /**
     * 
     */
    openOptions(): void {
        console.log("options");
        
    }

    /**
     * 
     * @param data 
     */
    submit(data: any) { 
        console.log(data);
    }
}
